<html>
   <head>
      <link rel="stylesheet" type="text/css" href="./css/style.css" />
      <link rel="stylesheet" type="text/css" href="./css/classic.css" />
   </head>
   <body>
      <!-- Header -->
      <div class="fixed">

         <!-- Topbar -->
         <div class="topbar">
            <a href="index.html"><span>Block View</span></a>
            <a href="classic.html"><span class="current">Classic View</span></a>
         </div>

         <div class="test" onclick="get_random_sequences()">
            Click to append 10 random sequences
         </div>
         <form>
            <textarea id="input" placeholder="Enter sequence(s) here"></textarea>
         </form>
      </div>

      <!-- Logo -->
      <div id="logo"></div>

      <!-- Scripts -->
      <script>
      function calculate_probability(char, sequence, sequences) {
         let p = {}
         sequences.forEach(function(seq) {
            let s = seq[char]
            p[s] = (p[s] > 0) ? p[s] += 1 : 1
         })
         return (p[sequence[char]] / sequences.length)
      }

      function create_logo(sequences) {
         const height = 400
         const colors = ['#8AFBFF', '#8AFF9F', '#FF80C5', '#81AAFF', '#FF9E9E', '#C1BEFF', '#22FADD', '#4AFF9C', '#CF80C5', '#FF5E9E', '#41AAFF', '#91BEFF', '#EEBBFF', '#BAFF9C', '#2F80C5', '#3F9E9E', '#C1AAFF', '#41BEFF']
         //
         // Functions for child elements scaled to probability
         get_height = (prob) => height * prob
         get_color = (char) => colors[all_chars.indexOf(char)]
         get_scale_factor = () => height * 0.013
         //
         // Store unique chars from all sequences
         let all_chars = []
         sequences.forEach(function(seq) {
            for (var j = 0; j < seq.length; j++) {
               let s = seq[j]
               if (!all_chars.includes(s)) all_chars.push(s)
            }
         })

         for (var i = 0; i < sequences[0].length; i++) {
            //
            // Create div for each sequence index
            let div = document.createElement('div')
            div.className = 'logo'
            //
            // p = char probabilities
            // chars = unique chars at index
            let p = {}
            let chars = []
            sequences.forEach(function(sequence) {
               let s = sequence.charAt(i)
               if (!chars.includes(s)) {
                  p[s] = calculate_probability(i, sequence, sequences)
                  chars.push(s)
               }
            })
            //
            // Append child div, span for each possile char with
            // span scaleY relative to probability
            chars.forEach(function(char) {
               div.innerHTML += '<div style="height:' + get_height(p[char]) + 'px;"><span style=\"color:' + get_color(char) + ';transform: scaleX(1.1) scaleY(' + (get_scale_factor() * p[char]) + ');\">' + char + '</span></div>'
            })
            // Append to container
            document.getElementById('logo').appendChild(div)
         }
         //
         // After append, scroll to bottom
         document.getElementById('logo').scrollTop = document.getElementById('logo').scrollHeight
      }

      function get_random_sequences() {
         let chars = ['A','A','A','F','L','K','K','K','P','P','G','T','L','S','V','R','M']
         let arr = []
         for (var i = 0; i < 9; i++) {
            let a = chars[Math.floor(Math.random() * chars.length)]
            for (var j = 0; j < 8; j++) {
               if (j == 3) a += 'P'
               else a += chars[Math.floor(Math.random() * chars.length)]
            }
            arr.push(a)
         }
         create_logo(arr)
      }

      function get_demo_sequences() {
         sequences = ['ALAKPAAAK','ALAKPAAAA', 'ALAKPAAAR', 'ALAKPAAAT', 'MLAKPAAAK', 'ALAKPAAMK', 'GILAPVFTK', 'TLNAPVKVV', 'KLNEPVLLL', 'AVVPPVVSV']
         create_logo(sequences)
      }

      window.onload = function() {
         //
         // Textarea focus and listener (allow shift+enter for newline;
         // enter key alone to submit)
         document.getElementById('input').focus()
         document.getElementById('input').onkeyup = function(event) {
            event = event || window.event
            if (event.keyCode == 13 && !event.shiftKey) {
               create_logo(this.value.trim().split(/\s+/))
               this.value = ''
            }
         }

         get_demo_sequences()
      }
      </script>
   </body>
</html>
